/**
 * @file test_creationclass.h
 */

/*****************************************************************************
**  $Id: test_creationclass.h,v 1.1 2003/07/01 15:51:48 andrew Exp $
**
**  This is part of the dxflib library
**  Copyright (C) 2001 Andrew Mustun
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU Library General Public License as
**  published by the Free Software Foundation.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************/

#ifndef TEST_CREATIONCLASS_H
#define TEST_CREATIONCLASS_H

#include "dl_creationinterface.h"



/**
 * This class takes care of the entities read from the file.
 * Usually such a class would probably store the entities.
 * this one just prints some information about them to stdout.
 *
 * @author Andrew Mustun
 */
class Test_CreationClass : public DL_CreationInterface {
public:
    Test_CreationClass();

    virtual void addLayer(const DL_LayerData& data);
    virtual void addBlock(const DL_BlockData& data) {}
    virtual void endBlock() {}
    virtual void addPoint(const DL_PointData& data);
    virtual void addLine(const DL_LineData& data);
    virtual void addArc(const DL_ArcData& data);
    virtual void addCircle(const DL_CircleData& data);
    virtual void addEllipse(const DL_EllipseData& data) {}
    virtual void addPolyline(const DL_PolylineData& data);
    virtual void addVertex(const DL_VertexData& data);
    virtual void addInsert(const DL_InsertData& data) {}
    virtual void addMText(const DL_MTextData& data) {}
    virtual void addMTextChunk(const char* text) {}
    virtual void addText(const DL_TextData& data) {}
    virtual void addDimAlign(const DL_DimensionData& data,
                             const DL_DimAlignedData& edata) {}
    virtual void addDimLinear(const DL_DimensionData& data,
                              const DL_DimLinearData& edata) {}
    virtual void addDimRadial(const DL_DimensionData& data,
                              const DL_DimRadialData& edata) {}
    virtual void addDimDiametric(const DL_DimensionData& data,
                                 const DL_DimDiametricData& edata) {}
    virtual void addDimAngular(const DL_DimensionData& data,
                               const DL_DimAngularData& edata) {}
    virtual void addDimAngular3P(const DL_DimensionData& data,
                                 const DL_DimAngular3PData& edata) {}
    virtual void addLeader(const DL_LeaderData& data) {}
    virtual void addLeaderVertex(const DL_LeaderVertexData& data) {}
    virtual void addHatch(const DL_HatchData& data) {}
    virtual void addHatchLoop(const DL_HatchLoopData& data) {}
    virtual void addHatchEdge(const DL_HatchEdgeData& data) {}
    virtual void endEntity() {}

    virtual void setVariableVector(const char* key,
                                   double v1, double v2, double v3, int code) {}
    virtual void setVariableString(const char* key,
                                   const char* value, int code) {}
    virtual void setVariableInt(const char* key, int value, int code) {}
    virtual void setVariableDouble(const char* key, double value, int code) {}

    void printAttributes();
};

#endif
